//============================================================================
// Name        : HW_01_03_11.cpp
// Author      : Michael Kitt
// Version     : 1.0
// Copyright   :
// Description : Estimates and Displays a value of e^x using Taylor expansion for a given x
//============================================================================

#include <iostream>
#include <cmath>

using namespace std;

//Declares function which estimates e^x
double ex_estimate(double chosen_x, int max_n);

int main ()
{
	const int MAX_N = 100;
	double x;

	//Asks user for value of x
	cout << "Enter desired value for x: ";
	cin >> x;


	//Outputs result of e^x estimation as well as the out put of the exp() function
	cout << "Estimated Value of e^x using factorial sum:  " << ex_estimate(x, MAX_N) << endl
		 << "Estimated Value of e^x using 'exp' function: " << exp(x);





    return 0;
}

double ex_estimate (double chosen_x, int max_n)
{
	int counter;
	double n_factorial = 1;
	double x_to_the_nth = 1;
	double ex;

	//Initializes before loop
	ex=1.0;
	x_to_the_nth=chosen_x;

	//estimates e^x using for loop
	for (counter=1; counter<=max_n; counter++)
	{
		n_factorial*=counter;
		ex+= x_to_the_nth / n_factorial;
		x_to_the_nth *= chosen_x;
	}
	return ex;
}
